unit BaseCamera;

interface

uses
    BaseTypes,
    BaseMath,
    GLViewVolume;

const
     SCALE_MOUSELOOK_X:single=10;
     SCALE_MOUSELOOK_Y:single=10;

type
    TCamera=class
                 private
                 fViewVolume:TViewVolume;
                 public
                 constructor Create;
                 destructor Destroy;override;
                 procedure SetView;virtual;
                 function GetRotation:TMatrix;virtual;

                 //It is the callers responsibility to make sure to call GetCursorPos and SetCursorPos
                 //before and after this
                 procedure LookWithMouse(mX,mY:integer);virtual;abstract;

                 property ViewVolume:TViewVolume
                          read fViewVolume
                          write fViewVolume;
    end;

implementation

{ TCamera }

constructor TCamera.Create;
begin
     inherited;
     fViewVolume:=TViewVolume.Create;
end;

destructor TCamera.Destroy;
begin
     fViewVolume.Free;
     inherited;
end;

function TCamera.GetRotation: TMatrix;
begin
     result:=GetIdentity;
end;

procedure TCamera.SetView;
begin
     fViewVolume.SetMatrix;     
end;

end.
